import { p as parsePackageName$1 } from './index-938f79c5.js';
var getPackageWithoutVersion = function (packages) {
    var packagesArray = packages.split('+');
    var newPackageArray = [];
    packagesArray.forEach(function (p) { return newPackageArray.push(parsePackageName$1(p).name); });
    return newPackageArray.join('+');
};
var RE_SCOPED = /^(@[^/]+\/[^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
var RE_NORMAL = /^([^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
var parsePackageName = function (input) {
    if (typeof input !== 'string') {
        throw new TypeError('Expected a string');
    }
    var matched = input.charAt(0) === '@' ? input.match(RE_SCOPED) : input.match(RE_NORMAL);
    if (!matched) {
        throw new Error("[parse-package-name] \"" + input + "\" is not a valid string");
    }
    return {
        name: matched[1],
        path: matched[2] || '',
        version: matched[3] || ''
    };
};
var packageToElementName = function (npmPackage) {
    var parsed = parsePackageName(npmPackage);
    if (parsed) {
        var tag = parsed.name.replace(/\/|\./g, '-');
        tag = tag.replace('@', '');
        return tag;
    }
};
export { getPackageWithoutVersion as g, packageToElementName as p };
