import { r as registerInstance, h } from './index-eb36fb29.js';
import './index-938f79c5.js';
import { g as getPackageWithoutVersion, p as packageToElementName } from './utils-af16fd11.js';
import { b as browser, d as docson, j as jsonBeautify, c as classnames, m as merge_1, t as throttle_1, i as index } from './browser-f69671c8.js';
import { c as createCommonjsModule, u as unwrapExports, a as cloneDeep_1 } from './identity-47313e7a.js';
import { r as range_1 } from './_setToString-59e11976.js';

var lib = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
class ModelUpdatedEvent extends CustomEvent {
    constructor(update, reset = false) {
        super(ModelUpdatedEvent.TYPE, { bubbles: true, detail: { update, reset } });
        this.update = update;
        this.reset = reset;
    }
}
ModelUpdatedEvent.TYPE = 'model.updated';
exports.ModelUpdatedEvent = ModelUpdatedEvent;
class DeleteImageEvent extends CustomEvent {
    constructor(src, done) {
        super(DeleteImageEvent.TYPE, { bubbles: true, detail: { src, done } });
        this.src = src;
        this.done = done;
    }
}
DeleteImageEvent.TYPE = 'delete.image';
exports.DeleteImageEvent = DeleteImageEvent;
class InsertImageEvent extends CustomEvent {
    constructor(handler) {
        super(InsertImageEvent.TYPE, { bubbles: true, detail: handler });
        this.handler = handler;
    }
}
InsertImageEvent.TYPE = 'insert.image';
exports.InsertImageEvent = InsertImageEvent;
class DeleteSoundEvent extends CustomEvent {
    constructor(src, done) {
        super(DeleteSoundEvent.TYPE, { bubbles: true, detail: { src, done } });
        this.src = src;
        this.done = done;
    }
}
DeleteSoundEvent.TYPE = 'delete.sound';
exports.DeleteSoundEvent = DeleteSoundEvent;
class InsertSoundEvent extends CustomEvent {
    constructor(handler) {
        super(InsertSoundEvent.TYPE, { bubbles: true, detail: handler });
        this.handler = handler;
    }
}
InsertSoundEvent.TYPE = 'insert.sound';
exports.InsertSoundEvent = InsertSoundEvent;

});

unwrapExports(lib);
var lib_2 = lib.DeleteImageEvent;
var lib_3 = lib.InsertImageEvent;

const pieDemoCss = "@import url(\"https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css\");@import url(\"https://fonts.googleapis.com/css?family=Roboto\");@import url(\"https://fonts.googleapis.com/icon?family=Material+Icons\");.docson{font-family:'Droid Sans',verdana,helvetica;font-size:13px;padding:6px 6px 6px 6px}.docson .box{position:relative;float:left;width:100%;background-color:rgba(255, 255, 255, 0.2);border:1px solid lightgrey;border-radius:4px;-moz-border-radius:4px;-webkit-border-radius:4px;padding-bottom:10px;-moz-box-shadow:1px 1px 1px darkgray;-webkit-box-shadow:1px 1px 1px darkgray;box-shadow:1px 1px 1px darkgray}.docson .expand-button{position:absolute;margin-top:15px;padding:2px;right:2px;float:right;width:18px;text-align:center;cursor:pointer;font-weight:bold;font-family:\"Lucida Console\", Monaco, monospace;font-size:15px;color:darkgray;display:none}.docson .source-button{position:absolute;padding:2px;margin-top:3px;right:2px;width:18px;text-align:center;cursor:pointer;font-weight:bold;font-family:\"Lucida Console\", Monaco, monospace;font-size:10px;color:darkgray;display:none}.docson .box-header{padding:6px;border-top-left-radius:4px;border-top-right-radius:4px;border-bottom:1px solid lightgrey;background:whitesmoke;}.docson .box-name{color:darkblue;padding:5px 40px 2px 3px;float:left;width:100%}.docson .title{margin-top:-3px;font-size:120%}.docson .link{text-decoration:underline}.docson .box-description{color:dimgray;float:left;width:100%}.docson .end{clear:both}.docson .error{color:red}.docson .box-body{padding-left:10px;padding-right:28px;clear:both}.docson .box-1{background:whitesmoke;}.docson .box-2{background:beige;background:-webkit-linear-gradient(white, beige, beige, gainsboro);background:-moz-linear-gradient(white, beige, beige, gainsboro)}.docson .box-3{background:azure;background:-webkit-linear-gradient(white, azure, azure, gainsboro);background:-moz-linear-gradient(white, azure, azure, gainsboro)}.docson .box-4{background:mistyrose;background:-webkit-linear-gradient(white, mistyrose, mistyrose, gainsboro);background:-moz-linear-gradient(white, mistyrose, mistyrose, gainsboro)}.docson .box-5{background:#ddffee;background:-webkit-linear-gradient(white, #ddffee, #ddffee, gainsboro);background:-moz-linear-gradient(white, #ddffee, #ddffee, gainsboro)}.docson .box-6{background:ghostwhite;background:-webkit-linear-gradient(white, ghostwhite, ghostwhite, gainsboro);background:-moz-linear-gradient(white, ghostwhite, ghostwhite, gainsboro)}.docson .box-7{background:lavenderblush;background:-webkit-linear-gradient(white, lavenderblush, lavenderblush, gainsboro);background:-moz-linear-gradient(white, lavenderblush, lavenderblush, gainsboro)}.docson .box-8{background:aliceblue;background:-webkit-linear-gradient(white, aliceblue, aliceblue, gainsboro);background:-moz-linear-gradient(white, aliceblue, aliceblue, gainsboro)}.docson .signature{padding-top:5px;clear:left}.docson .signature-header{padding-top:3px;height:20px;line-height:24px}.docson .property-name{float:left;width:100%;font-family:\"Lucida Console\", Monaco, monospace;min-width:130px}.docson .required{font-weight:bold}.docson .type-keyword{font-size:80%;color:dimgray}.docson .type-pattern{font-size:80%;color:darkolivegreen}.docson .type-enum{color:purple;font-family:\"Lucida Console\", Monaco, monospace;font-size:90%;padding-left:2px}.docson .type-default{color:darkslategrey;font-family:\"Lucida Console\", Monaco, monospace}.docson .signature-type{padding-left:6px;float:left;width:100%;min-width:160px}.docson .signature-type-any{font-style:italic}.docson .signature-type-string{color:green}.docson .signature-type-number{color:blue}.docson .signature-type-integer{color:blueviolet}.docson .signature-type-boolean{color:orangered}.docson .signature-type-null{font-family:\"Lucida Console\", Monaco, monospace;color:red}.docson .signature-type-date-time{color:#224466}.docson .signature-type-email{color:cornflowerblue}.docson .signature-type-hostname{color:darkolivegreen}.docson .signature-type-ipv6{color:darkslateblue}.docson .signature-type-ipv4{color:indigo}.docson .signature-type-uri{color:saddlebrown}.docson .signature-button{cursor:pointer;padding:4px;border-radius:4px;border:1px solid lightgrey;-moz-border-radius:4px}.docson .signature-type-ref{color:darkblue}.docson .signature-type-expanded{padding:5px 3px 3px 5px;vertical-align:-1px;opacity:0.6;-moz-box-shadow:inset 1px 1px 1px darkgray;-webkit-box-shadow:inset 1px 1px 1px darkgray;box-shadow:inset 1px 1px 1px darkgray}.docson .signature-description{padding-left:6px;padding-bottom:3px;color:dimgray;float:left;width:100%}.docson .signature-box-container{clear:both}.docson .box-container{float:left;width:100%;padding-top:4px;padding-left:8px;display:none}.docson .button{-webkit-touch-callout:none;-webkit-user-select:none;-khtml-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.docson .button:hover{color:darkred}@media all and (min-width: 20px) and (max-width: 500px){.docson .property-name{min-width:0px}.docson .signature-type{min-width:0px}.docson .source{width:100%}.docson .box-container,.box{width:100%}}.docson .desc{padding-left:6px;line-height:17px}.docson .desc p{margin:0;margin-top:3px}.docson .desc code{color:purple;font-size:90%}.docson .desc table{margin-top:4px;margin-bottom:4px;border-collapse:collapse}.docson .desc th{padding:0px;font-size:80%;font-weight:normal;background:rgba(231, 231, 231, 0.5)}.docson .desc table,.docson .desc th,.docson .desc td{border:1px solid lightgrey}.docson .desc tr>td{padding:2px 6px 2px 6px}.docson .desc h1{font-size:120%;margin-top:0px;margin-bottom:3px}.docson .desc h2{font-size:115%;margin-top:0px;margin-bottom:3px}.docson .desc h3{font-size:110%;margin-top:0px;margin-bottom:3px}.docson .desc h4{font-size:100%;margin-top:0px;margin-bottom:3px}.docson .desc pre{border:1px solid lightgray;border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px;padding:4px;margin:3px 0px}.docson .desc ul{padding-left:16px;margin:3px 0px}.docson .desc ol{padding-left:16px;margin:3px 0px}.docson .desc blockquote{margin:3px 0px 3px 10px;padding-left:6px;border-left:1px solid lightgray}.docson .desc img{vertical-align:middle}.docson .desc hr{border:0;height:1px;background:lightgrey;color:lightgrey;width:50%}.docson .source{display:none;padding-left:16px;padding-right:30px}.docson .json,.json-schema{font-family:\"Lucida Console\", Monaco, monospace}.docson .json-punctuation{font-weight:bold}.docson .json-null,.json-true,.json-false{font-weight:bold}.docson .json-true{color:#080}.docson .json-false{color:#800}.docson .json-object-key{color:#246}.docson .json-keyword{font-weight:bold;color:#036}.docson .json-number{font-weight:bold;color:#660}.docson .json-string{color:#800}.docson .json-schema-map>.json-object-key{color:#080;font-style:italic}html,body{height:100%;margin:0;padding:0}.doc-holder{background-color:rgba(0, 0, 0, 0.2);-ms-flex-align:end;align-items:flex-end;bottom:0;display:none;-ms-flex-direction:column;flex-direction:column;position:fixed;right:0;top:0;width:100%;z-index:101}.doc-holder .close-icon{margin:0;position:absolute;right:20px;top:20px;z-index:1}.doc-holder #schema-holder{padding:0;height:100%;width:70%}.doc-holder #schema-holder .box{background:#fff;height:100%}.doc-holder #schema-holder .box .box-body{height:calc(100% - 85px);overflow:scroll}.doc-holder #schema-holder>.box>.box-header{background-color:#3f51b5;height:65px}.doc-holder #schema-holder>.box>.box-header .box-title .box-description p{color:#ffffff;font-size:20px;font-weight:500;line-height:65px}.doc-holder.mobile #schema-holder{width:100%}.doc-holder.visible{display:-ms-flexbox;display:flex}mjx-container.MathJax *:not(mjx-math){font-family:inherit}*:not(i){font-family:Roboto, serif}.root{background-color:#3f51b5;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;max-height:100%;height:100%;position:relative}.root.multiplePies{height:50%}.root.loading{background:transparent}.control-bar{color:grey;display:-ms-flexbox;display:flex;font-size:16px;font-weight:bold;min-height:76px;-ms-flex-pack:justify;justify-content:space-between;width:100%}.control-bar.justElement{display:none}.control-bar .collapse-icon{border-radius:4px;border:1px solid #3f51b5;color:#3f51b5;font-size:16px;margin-right:18px;padding:7px}.control-bar .collapse-icon.collapsed{background-color:#3f51b5;color:#fff}.control-bar .toggle-icon{cursor:pointer;margin-right:20px}.control-bar .toggle-icon.toggled{color:#f9a825}.control-bar .authoring-header{background:#fff;-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;height:76px;-ms-flex-pack:center;justify-content:center;position:relative}.control-bar .authoring-header .topContent .toggle-text{font-size:12px;margin-right:10px}.control-bar .authoring-header .bottomContent{background:#fff;bottom:0;display:none;height:calc(100vh - 76px);left:0;position:absolute;top:76px;width:100%;z-index:100}.control-bar .authoring-header .bottomContent .tabs-container{height:100%}.control-bar .authoring-header .bottomContent .tabs-container .tab-content{height:calc(100% - 52px)}.control-bar .authoring-header .bottomContent .json-config{-ms-flex-align:start;align-items:flex-start;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;height:100%;padding:16px;width:100%}.control-bar .authoring-header .bottomContent .json-config .json-config-header{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;padding:16px 0;width:100%}.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between}.control-bar .authoring-header .bottomContent .json-config .json-config-header .view-container,.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content>div{cursor:pointer}.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content .copy-container{margin-right:25px}.control-bar .authoring-header .bottomContent .json-config .json-config-header i{margin-right:8px}.control-bar .authoring-header .bottomContent .json-config textarea{resize:none}.control-bar .authoring-header .bottomContent .json-config .json-content{background-color:#ffffff;border:1px solid #ddd;-webkit-box-shadow:0 8px 10px 0 rgba(0, 0, 0, 0.07), 0 2px 4px 0 rgba(0, 0, 0, 0.05);box-shadow:0 8px 10px 0 rgba(0, 0, 0, 0.07), 0 2px 4px 0 rgba(0, 0, 0, 0.05);-webkit-box-sizing:border-box;box-sizing:border-box;color:#000000;font-size:12px;height:100%;padding:16px;width:100%}.close-icon{background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;color:#3f51b5;cursor:pointer;font-size:12px;height:32px;line-height:32px;margin-right:18px;text-align:center;width:32px}.control-bar .header-title{display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;-ms-flex-direction:column;flex-direction:column;margin-left:24px}.control-bar .header-title .title-info{display:-ms-flexbox;display:flex;-ms-flex-pack:start;justify-content:flex-start}.control-bar .header-title .title-info .option{margin-right:5px;text-transform:uppercase}.control-bar .header-title .title-info i{font-size:4px;margin-right:5px;vertical-align:middle}.control-bar .header-title span{font-size:12px;font-weight:300;line-height:1.5;color:rgba(0, 0, 0, 0.56)}.control-bar .header-title .title-info h4{color:rgba(0, 0, 0, 0.87);font-size:16px;font-weight:500;margin:0 8px 4px 0;text-align:left}.control-bar .student-view-header.collapsed,.control-bar .authoring-header.collapsed{max-width:56px}.control-bar .authoring-header.collapsed .header-title,.control-bar .student-view-header.collapsed .header-title{display:none}.control-bar .authoring-header.collapsed i,.control-bar .student-view-header.collapsed i{margin:0}.control-bar .authoring-header.collapsed .buttons-container,.control-bar .student-view-header.collapsed .buttons-container{display:none}.control-bar .student-view-header{background:#fff;-ms-flex:1 0 0px;flex:1 0 0;height:76px}.control-bar .student-view-header .bottomContent{display:none}.control-bar .bottomContent .tabs-container{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:relative}.control-bar .bottomContent .tabs-container .tabs{background-color:#fafafa;border-bottom:4px solid #eeeeee;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;height:48px;-ms-flex-pack:start;justify-content:flex-start}.control-bar .bottomContent .tabs-container .tabs .tab{cursor:pointer;color:#000;min-width:100px;height:48px;line-height:48px;text-align:center;width:135px}.control-bar .bottomContent .tabs-container .selected-line{background-color:#3f51b5;bottom:4px;height:4px;position:absolute;top:48px;-webkit-transition:all 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;transition:all 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms}.control-bar .bottomContent .tabs-container .tab-content{height:78px}.control-bar .student-view-header.toggled{height:210px}.control-bar .toggled .bottomContent{display:block;height:134px}.control-bar .toggled .topContent{height:76px}.control-bar .topContent{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;height:100%;width:100%}.control-bar .topContent .mobile-button{width:auto}.control-bar .topContent .toggle-text{font-size:12px;margin-right:10px}.control-bar .topContent .buttons-container{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;padding:0 16px}.control-bar .topContent .buttons-container .toggle-container{-ms-flex-align:center;align-items:center;background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;cursor:pointer;display:-ms-flexbox;display:flex;height:32px;-ms-flex-pack:justify;justify-content:space-between;margin-right:5px;padding:8px;width:105px}.control-bar .topContent .buttons-container .toggle-container.student{width:82px}.control-bar .topContent .buttons-container .toggle-container i{color:#3f51b5;font-size:16px;margin-right:0}.control-bar .topContent .buttons-container .toggle-container .toggle-text{color:#3f51b5;margin-right:0 !important}.control-bar .topContent .buttons-container .toggle-container.toggled{background-color:#3f51b5}.control-bar .topContent .buttons-container .toggle-container.toggled i{color:#fff}.control-bar .topContent .buttons-container .toggle-container.toggled .toggle-text{color:#fff}.control-bar .topContent h4{margin-bottom:10px}.control-bar .student-view-header .bottomContent{height:126px}.control-bar .bottomContent .settings-tab-container{background-color:#fff;-ms-flex-align:start;align-items:flex-start;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;height:100%;-ms-flex-pack:start;justify-content:flex-start;padding-left:20px;width:100%}.control-bar .bottomContent .settings-tab-container .roles-settings,.control-bar .bottomContent .settings-tab-container .modes-settings{-ms-flex-item-align:center;align-self:center}.control-bar .bottomContent .settings-tab-container .roles-settings h5,.control-bar .bottomContent .settings-tab-container .modes-settings h5{font-size:12px;margin:0 0 8px 0}.control-bar .bottomContent .settings-tab-container .roles-settings .roles-options,.control-bar .bottomContent .settings-tab-container .modes-settings .modes-options{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center}.control-bar .bottomContent .settings-tab-container .roles-settings .roles-options>*,.control-bar .bottomContent .settings-tab-container .modes-settings .modes-options>*{margin-right:18px}.control-bar.mobile{-ms-flex-align:center;align-items:center;background:#fff;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;min-height:76px;width:100%}.control-bar.mobile .buttons{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;height:76px;-ms-flex-pack:justify;justify-content:space-between;padding:0 16px;width:100%}.mobile-button{-ms-flex-align:center;align-items:center;background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;cursor:pointer;display:-ms-flexbox;display:flex;height:32px;-ms-flex-pack:justify;justify-content:space-between;margin-right:5px;padding:8px;width:105px}.mobile-button span{color:#3f51b5;font-size:14px !important;line-height:1.39;letter-spacing:normal;margin:0 !important}.control-bar.mobile .student-tab-content{width:100%}.control-bar.mobile .student-tab-content .toggle-settings{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:start;justify-content:flex-start;margin-bottom:20px;padding:0 20px;width:400px}.control-bar.mobile .student-tab-content .toggle-settings span{font-size:12px;margin-right:10px}.control-bar.mobile .student-tab-content .bottomContent{display:none}.control-bar.mobile.toggled .student-tab-content .bottomContent{display:block;height:134px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller{display:block;height:204px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container{-webkit-box-sizing:border-box;box-sizing:border-box;-ms-flex-direction:column;flex-direction:column;padding:20px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container .roles-settings{-ms-flex-item-align:start;align-self:flex-start}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container .modes-settings{-ms-flex-item-align:start;align-self:flex-start;margin-bottom:20px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .tabs-container .tab-content{height:152px}.smaller-view{height:100%;width:100%}.smaller-view .authoring-holder{height:calc(100% - 76px)}.smaller-view .student-view-holder{height:calc(100% - 120px)}.smaller-view .student-view-holder.toggled{height:calc(100% - 254px)}.smaller-view .element-holder{border:16px solid #3f51b5;-ms-flex:1;flex:1;height:calc(100% - 32px);overflow:scroll;width:98%}.smaller-view .element-parent{background:#fff;border-radius:4px;overflow:scroll;padding:20px}.smaller-view .element-holder{width:98%}.smaller-view.mobile .authoring-header:not(.toggled){height:100px}.smaller-view.mobile .topContent .buttons-container{width:100%}.smaller-view.mobile .authoring-header:not(.toggled) .topContent{-ms-flex-align:start;align-items:flex-start;-ms-flex-direction:column;flex-direction:column}.smaller-view.mobile .authoring-header:not(.toggled) .topContent .header-title{margin-left:16px;max-height:36px !important}.smaller-view.mobile .authoring-header:not(.toggled) .topContent .header-title span{display:none}.smaller-view.mobile .authoring-header.toggled .topContent .header-title{width:100%}.smaller-view.mobile .authoring-header.toggled .topContent .header-title span{font-size:10px}.config-holder{background-color:#3f51b5;display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;height:100%;width:100%}.config-holder .element-holder{position:absolute;top:76px;left:0;width:96%;overflow:auto;border:16px solid #3f51b5;-ms-flex:1;flex:1;height:calc(100% - 108px)}.config-holder .element-holder.justElement{top:0}.config-holder .element-holder.toggled{top:210px}.config-holder .element-parent{background:#fff;border-radius:4px;overflow:auto;padding:20px;position:relative}.config-holder .collapsed-panel{-ms-flex-pack:center;justify-content:center;background:#fff;display:-ms-flexbox;display:flex;color:#707070;max-width:56px;-ms-flex:1;flex:1}.config-holder .collapsed-panel span{line-height:1.83;-webkit-text-orientation:upright;text-orientation:upright;text-transform:uppercase;-webkit-writing-mode:tb-rl;-ms-writing-mode:tb-rl;writing-mode:tb-rl}.config-holder .authoring-holder{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex:1 0 0px;flex:1 0 0;position:relative}.config-holder .authoring-holder.collapsed{max-width:56px}.toggle-button{background-color:lightgrey;border:none;cursor:pointer;outline:none}.divider{background:#2336a0;-ms-flex:1;flex:1;max-width:2px !important;z-index:9}.divider:after{background-color:#ebebeb;content:\"\";display:block;height:76px;width:2px}.divider.larger:after{height:210px}.config-holder .student-view-holder{display:-ms-flexbox;display:flex;-ms-flex:1 0 0px;flex:1 0 0;-ms-flex-direction:column;flex-direction:column;position:relative}.config-holder .student-view-holder.collapsed{max-width:56px}.score-holder{background:#fff;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;display:none;margin-bottom:40px;min-height:40px;overflow:scroll;padding:20px;width:100%}.score-holder.visible{display:block}.score-holder .score{margin-bottom:10px}.score-holder pre{border:solid 1px rgba(0, 0, 0, 0.14);background-color:white;padding:8px}.custom-checkbox{display:-ms-inline-flexbox;display:inline-flex;-ms-flex-align:center;align-items:center}.custom-checkbox i{color:#3f51b5;margin-right:8px}[class*=\"MuiCheckbox-checked\"]{color:green !important}.root .lmask{position:absolute;height:100%;width:100%;background-color:#fff;bottom:0;left:0;right:0;top:0;z-index:9999;opacity:0.4}.root .lmask.fixed{position:fixed}.root .lmask:before{content:\"\";background-color:rgba(0, 0, 0, 0);border:5px solid rgba(63, 81, 181, 0.9);opacity:0.9;border-right:5px solid rgba(0, 0, 0, 0);border-left:5px solid rgba(0, 0, 0, 0);border-radius:50px;-webkit-box-shadow:0 0 35px rgba(63, 81, 181, 0.9);box-shadow:0 0 35px rgba(63, 81, 181, 0.9);width:50px;height:50px;-moz-animation:spinPulse 1s infinite ease-in-out;-webkit-animation:spinPulse 1s infinite linear;margin:-25px 0 0 -25px;position:absolute;top:50%;left:50%}.root .lmask:after{content:\"\";background-color:rgba(0, 0, 0, 0);border:5px solid rgba(63, 81, 181, 0.9);opacity:0.9;border-left:5px solid rgba(0, 0, 0, 0);border-right:5px solid rgba(0, 0, 0, 0);border-radius:50px;-webkit-box-shadow:0 0 15px rgba(63, 81, 181, 0.9);box-shadow:0 0 15px rgba(63, 81, 181, 0.9);width:30px;height:30px;-moz-animation:spinoffPulse 1s infinite linear;-webkit-animation:spinoffPulse 1s infinite linear;margin:-15px 0 0 -15px;position:absolute;top:50%;left:50%}@-webkit-keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63, 81, 181, 0.9);box-shadow:0 0 1px rgba(63, 81, 181, 0.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}100%{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}@keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63, 81, 181, 0.9);box-shadow:0 0 1px rgba(63, 81, 181, 0.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}100%{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}@-webkit-keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}";

const log = browser("pie-framework:pie-demo");
var ViewState;
(function (ViewState) {
    ViewState[ViewState["LOADING"] = 0] = "LOADING";
    ViewState[ViewState["READY"] = 1] = "READY";
    ViewState[ViewState["ERROR"] = 2] = "ERROR";
})(ViewState || (ViewState = {}));
const defaultController = {
    model: (model, session, env) => {
        log(model, session, env);
        return Object.assign(Object.assign({}, model), { mode: env.mode });
    },
    outcome: () => ({
        score: 0,
        details: {}
    })
};
const PieDemo = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        /**
         * Removes control bar if true
         * @type {boolean}
         */
        this.justElement = false;
        /**
         * Makes the element have 50% height
         * @type {boolean}
         */
        this.multiplePies = false;
        /**
         * Link to the pie-schema markdown file
         * @type {boolean}
         */
        this.modelSchemaJSONURI = null;
        /**
         * Link to the pie-schema markdown file
         * @type {boolean}
         */
        this.configureSchemaJSONURI = null;
        /**
         * Tells the component if it needs to load the elements or not
         */
        this.load = true;
        /**
         * Include an editor in the view
         */
        this.editor = true;
        /**
         * Include an item preview in the view
         */
        this.preview = true;
        /**
         * Include control panel for adjusting player settings.
         */
        this.playerControls = true;
        this.state = ViewState.LOADING;
        this.minHeightAuthoring = "initial";
        this.minHeightStudent = "initial";
        this.rootElWidth = 1250;
        this.bottomContElWidth = 550;
        this.tabIndex = 0;
        this.mobileTabIndex = 0;
        this.currentOption = "student";
        this.studSettVisible = false;
        this.authSettVisible = false;
        this.docHolderVisible = false;
        this.env = { mode: "gather" };
        this.session = {};
        this.scoring = {
            score: 0,
            json: ""
        };
        this.jsonConfigValue = null;
        this._renderStudent = false;
        this.imageHandler = null;
        this.configureSchemaJSON = null;
        this.modelSchemaJSON = null;
        this.cachedJsonConfig1 = null;
        this.cachedJsonConfig2 = null;
        this.rootEl = null;
        this.fileInput = null;
        this._renderingAuthor = false;
        this._renderingStudent = false;
        this.viewDocumentation = tabIndex => {
            log("Tab Index", tabIndex);
            const currentContent = tabIndex === 1 ? this.modelSchemaJSON : this.configureSchemaJSON;
            this.docHolderVisible = true;
            docson.doc("schema-holder", currentContent);
        };
        this.renderJsonConfigPanel = (jsonData, index) => {
            log(jsonData);
            return (h("div", { class: "json-config" }, h("div", { class: "json-config-header" }, h("div", { class: "view-container", onClick: () => this.viewDocumentation(index) }, h("i", { class: "fa fa-desktop" }), h("span", null, "View Documentation")), h("div", { class: "right-content" }, h("div", { class: "copy-container", onClick: () => {
                    this[`textAreaContentRef${index}`].select();
                    document.execCommand("copy");
                } }, h("i", { class: "fa fa-clone" }), h("span", null, "Copy JSON")), h("div", { class: "reset-container", onClick: () => {
                    if (this[`textAreaContentRef${index}`]) {
                        this[`textAreaContentRef${index}`].value = jsonBeautify(this[`cachedJsonConfig${index}`], null, 2, 98);
                        if (index === 1) {
                            this.configModel = this[`cachedJsonConfig${index}`];
                        }
                        else {
                            this.configureObject = this[`cachedJsonConfig${index}`];
                        }
                    }
                } }, h("i", { class: "fa fa-undo" }), h("span", null, "Reset")))), h("textarea", { ref: el => (this[`textAreaContentRef${index}`] = el), class: "json-content", value: jsonBeautify(jsonData, null, 2, 98), onChange: e => {
                    const target = e.target;
                    if (index === 1) {
                        this.configModel = JSON.parse(target.value);
                    }
                    else {
                        this.configureObject = JSON.parse(target.value);
                    }
                } })));
        };
        this.renderTabs = (tabs, tabWidth = 100) => {
            const content = tabs[this.tabIndex] ? tabs[this.tabIndex].content : null;
            const contentValue = typeof content === "function" ? content() : content;
            return (h("div", { class: "tabs-container" }, h("div", { class: "tabs" }, tabs.map((tab, index) => (h("div", { style: {
                    width: `${tabWidth}px`
                }, class: classnames("tab", {
                    selected: this.tabIndex === index
                }), onClick: () => (this.tabIndex = index) }, tab.name)))), h("span", { class: "selected-line", style: {
                    left: `${this.tabIndex * tabWidth}px`,
                    width: `${tabWidth}px`
                } }), h("div", { class: "tab-content" }, contentValue)));
        };
        this.renderAuthoringHolder = (smallView = false) => {
            const ConfigTag = this.pieName + "-config";
            const isCollapsed = this.collapsed === "authoring";
            const config = {
                id: "1",
                elements: {
                    [ConfigTag]: this.pie
                },
                models: [
                    this.configModel
                ],
                markup: `
          <${ConfigTag} id='1'></${ConfigTag}>
        `
            };
            const configSettings = {
                [getPackageWithoutVersion(this.pie)]: this.configureObject
            };
            this._renderingAuthor = true;
            return (h("div", { class: classnames("authoring-holder", {
                    collapsed: this.collapsed === "authoring",
                    toggled: this.isToggled()
                }) }, h("div", { class: classnames("control-bar", {
                    justElement: this.justElement
                }) }, this.renderAuthoringHeader(smallView)), isCollapsed &&
                this.renderCollapsedPanel("Authoring View", this.isToggled()), !isCollapsed && (h("div", { ref: el => el && (this.elementParent1 = el), class: classnames("element-holder", {
                    justElement: this.justElement
                }) }, h("div", { class: "element-parent", style: {
                    minHeight: `${this.minHeightAuthoring}px`
                } }, h("pie-author", { class: "pie-author", ref: el => el && (this.pieAuthor = el), config: config, configSettings: configSettings, reFetchBundle: true }, " ")))), h("input", { type: "file", hidden: true, ref: r => (this.fileInput = r) })));
        };
        this.renderStudentHolder = (smallView = false) => {
            const TagName = this.pieName + "";
            const isCollapsed = this.collapsed === "student";
            const config = {
                id: "1",
                elements: {
                    [TagName]: this.pie
                },
                models: [
                    this.configModel
                ],
                markup: `
          <${TagName} id='1'></${TagName}>
        `
            };
            this._renderingStudent = true;
            if (!this._renderStudent) {
                return null;
            }
            return (h("div", { class: classnames("student-view-holder", {
                    collapsed: this.collapsed === "student",
                    toggled: this.isToggled()
                }) }, h("div", { class: classnames("control-bar", {
                    justElement: this.justElement
                }) }, this.renderStudentHeader(smallView)), isCollapsed && this.renderCollapsedPanel("Student View"), !isCollapsed && (h("div", { class: classnames("element-holder", {
                    toggled: this.studSettVisible,
                    justElement: this.justElement
                }) }, h("div", { class: classnames("score-holder", {
                    visible: this.env["mode"] === "evaluate"
                }) }, h("div", { class: "score" }, h("span", null, "Score: "), " ", this.scoring.score), h("pre", null, this.scoring.json)), h("div", { ref: el => el && (this.elementParent2 = el), class: "element-parent", style: {
                    minHeight: `${this.minHeightStudent}px`
                } }, h("pie-player", { class: "pie-player", ref: el => el && (this.piePlayer = el), config: config, reFetchBundle: true }, " "))))));
        };
        this.renderContent = () => {
            if (this.rootElWidth >= 1200) {
                return (h("div", { class: "config-holder" }, this.renderAuthoringHolder(), h("span", { class: classnames("divider", {
                        larger: this.studSettVisible && this.authSettVisible
                    }) }), this.renderStudentHolder()));
            }
            return (h("div", { class: classnames("smaller-view", {
                    mobile: this.rootElWidth <= 700
                }) }, this.mobileTabIndex === 0 && this.renderAuthoringHolder(true), this.mobileTabIndex === 1 && this.renderStudentHolder(true)));
        };
        this.renderDocHolder = () => {
            return (h("div", { class: classnames("doc-holder", {
                    visible: this.docHolderVisible,
                    mobile: this.rootElWidth <= 700
                }) }, h("span", { class: "close-icon", onClick: () => (this.docHolderVisible = false) }, "X"), h("div", { id: "schema-holder" })));
        };
        this.handleFileInputChange = (e) => {
            const input = e.target;
            if (!this.imageHandler) {
                console.error("no image handler - but file input change triggered?");
                return;
            }
            log("[handleInputFiles] input.files: ", input);
            const files = input.files;
            if (files.length < 1 || !files[0]) {
                log("[handleInputFiles] = !!! no files.");
                this.imageHandler.cancel();
                this.imageHandler = null;
            }
            else {
                const file = files[0];
                this.imageHandler.fileChosen(file);
                this.fileInput.value = "";
                const reader = new FileReader();
                reader.onload = () => {
                    log("[reader.onload]");
                    const dataURL = reader.result;
                    setTimeout(() => {
                        this.imageHandler.done(null, dataURL.toString());
                        this.imageHandler = null;
                    }, 2000);
                };
                log("call readAsDataUrl...", file);
                let progress = 0;
                this.imageHandler.progress(progress, 0, 100);
                range_1(1, 100).forEach(n => {
                    setTimeout(() => {
                        this.imageHandler.progress(n, n, 100);
                    }, n * 20);
                });
                reader.readAsDataURL(file);
            }
        };
        this.handleRootEl = this.handleRootEl.bind(this);
        this.handleInsertImage = (e) => {
            log("[handleInsertImage] fileInput:", this.fileInput);
            this.imageHandler = e.detail;
            this.fileInput.click();
        };
        this.handleDeleteImage = (e) => {
            e.detail.done();
        };
    }
    componentDidUpdate() {
        if (this.pieAuthor) {
            const authorElName = `${Object.keys(this.pieAuthor.config.elements)[0]}-config`;
            if (authorElName) {
                let findEl;
                if (!this.authorElement) {
                    findEl = true;
                }
                else {
                    const tagName = this.authorElement.tagName.toLowerCase();
                    findEl = tagName !== authorElName;
                }
                if (findEl) {
                    this.authorElement = document.querySelector(authorElName);
                }
            }
        }
        if (this.fileInput) {
            this.fileInput.addEventListener("change", this.handleFileInputChange);
        }
        const isAuthoringToggled = this.isToggled("authoring");
        if (isAuthoringToggled) {
            let offset = 0;
            if (this.bottomContentRef) {
                const ref = this.bottomContentRef.querySelector(".tabs");
                if (ref) {
                    const clientRect = ref.getBoundingClientRect();
                    offset = clientRect.y;
                    this.bottomContentRef.style.height = `calc(100vh - ${offset}px)`;
                }
            }
        }
    }
    collapsePanel(name) {
        this.collapsed = this.collapsed === name ? null : name;
    }
    toggleAuthoringSettings() {
        this.authSettVisible = !this.authSettVisible;
    }
    async validateItem() {
        if (this.pieController && this.pieController.model) {
            try {
                const errors = await this.pieController.validate(this.configModel, this.configure);
                console.warn('errors = ', errors);
                this.updateModel(Object.assign(Object.assign({}, this.configModel), { errors }));
            }
            catch (e) {
                console.error(e.toString());
            }
        }
    }
    toggleStudentSettings() {
        this.studSettVisible = !this.studSettVisible;
    }
    isToggled(type = "student") {
        if (type === "student") {
            return this.studSettVisible && this.collapsed !== "student";
        }
        return this.authSettVisible && this.collapsed !== "authoring";
    }
    detachListeners() {
        if (this.configElement) {
            this.configElement.removeEventListener("model.updated", this.handleSetConfigElement);
        }
        if (this.rootEl) {
            this.rootResizeObserver.unobserve(this.rootEl);
        }
    }
    watchPie(newPie) {
        log("[watchPie] ", newPie);
        this.package = newPie;
        this.pieName = newPie
            .substr(newPie.lastIndexOf("/") + 1, newPie.length)
            .split("@")[0];
        if (this.pieName.indexOf("-") < 0) {
            this.pieName = `x-${this.pieName}`;
        }
        customElements.whenDefined(`pp-${packageToElementName(this.pie)}`).then(async () => {
            // TODO - what if same element reloaded, could elems be redefined? may need to undefine prior?
            const packageWithoutVersion = getPackageWithoutVersion(this.package);
            this.pieController =
                (window["pie"].default[packageWithoutVersion] && window["pie"].default[packageWithoutVersion].controller) ||
                    defaultController;
            if (this.model) {
                this.updatePieModelFromController(this.model, this.session, this.env);
            }
            this.state = ViewState.READY;
        });
        if (this.load) {
            this.state = ViewState.READY;
        }
    }
    updateModel(newModel) {
        this.configModel = newModel;
    }
    async updateConfigure(newConfigure) {
        this.configureObject = newConfigure;
    }
    watchConfigModel(newModel) {
        if (this.configElement)
            this.configElement.model = newModel;
        this.updatePieModelFromController(newModel, this.session, this.env, true);
    }
    async updatePieModelFromController(model, session, env, shouldResetSession) {
        if (this.pieController && this.pieController.model) {
            const newConfig = await this.pieController.model(model, session, env);
            if (this.env["mode"] === "evaluate") {
                const scoring = await this.pieController.outcome(this.configModel, this.session, this.env);
                this.scoring = {
                    score: scoring.score,
                    json: jsonBeautify(scoring.details, null, 2, 80)
                };
            }
            if (this.piePlayer) {
                const ConfigTag = this.pieName + "-config";
                const newModel = merge_1(cloneDeep_1(this.configModel));
                const config = {
                    id: "1",
                    elements: {
                        [ConfigTag]: this.pie
                    },
                    models: [
                        newModel
                    ],
                    markup: `
          <${ConfigTag} id='1'></${ConfigTag}>
        `
                };
                // if the model or config changes, we need to reset session (to avoid the possibility of having a non-valid session)
                if (shouldResetSession) {
                    this.piePlayer.session.data = [];
                }
                this.piePlayer.config = config;
            }
        }
    }
    watchPieElement(pieElement) {
        if (pieElement && !pieElement.model) {
            pieElement.model = this.pieElementModel;
        }
    }
    watchPieElementModel(newModel) {
        if (this.pieElement) {
            this.pieElement.model = newModel;
            this.pieElement.configuration = this.configureObject;
        }
    }
    handleRootEl(current) {
        if (current) {
            this.rootEl = current;
            this.rootResizeObserver.observe(current, {
                attributes: true,
                childList: true,
                subtree: true
            });
        }
        else if (this.rootEl) {
            this.rootResizeObserver.unobserve(this.rootEl);
        }
    }
    componentWillLoad() {
        log("component will load ... ");
        this.watchPie(this.pie);
        const rootHandler = throttle_1(() => {
            if (this.rootEl) {
                this.rootElWidth = this.rootEl.offsetWidth;
            }
        }, 1000, { leading: true });
        this.rootResizeObserver = new index(rootHandler);
        if (this.model) {
            this.updateModel(this.model);
        }
        if (this.configure) {
            this.updateConfigure(this.configure);
        }
        if (this.modelSchemaJSONURI) {
            this.watchModelSchemaJSONURI(this.modelSchemaJSONURI);
        }
        if (this.configureSchemaJSONURI) {
            this.watchConfigureSchemaJSONURI(this.configureSchemaJSONURI);
        }
        window.global = window;
        docson.templateBaseUrl = "/assets/html";
    }
    handleElementResize(el, name) {
        let minHeight = "initial";
        const navigateNode = el => {
            if (el.nodeType === 1) {
                const allStyle = getComputedStyle(el);
                if (!el.matches(".element-holder") &&
                    allStyle.position === "absolute") {
                    const bounding = el.getBoundingClientRect();
                    const currentHeight = bounding.top + bounding.height;
                    if (minHeight === "initial" || currentHeight > minHeight) {
                        minHeight = currentHeight;
                    }
                }
                if (el.childNodes.length > 0) {
                    el.childNodes.forEach(ch => navigateNode(ch));
                }
            }
        };
        navigateNode(el);
        this[name] = minHeight;
    }
    /**
     * Pick up @pie-framework/pie-configure-events and trigger an update.
     * TODO: Why cant i use ModelUpdatedEvent.TYPE in the decorator?
     */
    onModelUpdated(event) {
        if (this._renderingAuthor || this._renderingStudent) {
            this._renderingAuthor = false;
            this._renderingStudent = false;
            return;
        }
        log("MODEL UPDATED: target:", event.target, event.detail);
        // this.model = event.detail.update;
        this.updatePieModelFromController(event.detail.update, this.session, this.env, true);
    }
    onModelLoaded() {
        if (!this._renderStudent) {
            this._renderStudent = true;
        }
    }
    onSessionChanged(event) {
        log("MODEL UPDATED: target:", event.target, event.detail);
        if (event.target) {
            this.session = event.target.session;
        }
    }
    watchConfigElement(el) {
        if (!el) {
            return;
        }
        el.addEventListener(lib_3.TYPE, this.handleInsertImage);
        el.addEventListener(lib_2.TYPE, this.handleDeleteImage);
    }
    watchModelSchemaJSONURI(newUrl) {
        if (newUrl) {
            fetch(newUrl, {
                mode: "cors"
            })
                .then((response) => response.json())
                .then(response => {
                this.modelSchemaJSON = response;
            });
        }
    }
    watchConfigureSchemaJSONURI(newUrl) {
        if (newUrl) {
            fetch(newUrl, {
                mode: "cors"
            })
                .then((response) => response.json())
                .then(response => {
                this.configureSchemaJSON = response;
            });
        }
    }
    setMode(mode) {
        this.env = Object.assign(Object.assign({}, this.env), { mode: mode });
        if (this.piePlayer) {
            this.piePlayer.env = { mode: mode, role: this.currentOption };
        }
        this.updatePieModelFromController(this.configModel, this.session, this.env);
    }
    setOption(option) {
        this.currentOption = option;
        if (this.piePlayer) {
            this.piePlayer.env = { mode: this.env['mode'], role: this.currentOption };
        }
    }
    customCheckBox({ label, checked, value, action = undefined }) {
        return (h("label", { class: "custom-checkbox", onClick: () => action.call(this, value) }, h("i", { class: "material-icons" }, checked ? "radio_button_checked" : "radio_button_unchecked"), h("span", null, label)));
    }
    renderHeaderTitleInfo({ title, description, options = undefined }) {
        return (h("div", { class: "header-title" }, h("div", { class: "title-info" }, h("h4", null, title), options &&
            options.map(opt => (h("span", { class: "option" }, h("i", { class: "fa fa-circle" }), opt)))), h("span", null, description)));
    }
    renderAuthoringBottomContent() {
        return this.renderTabs([
            {
                name: "Item Model",
                content: () => {
                    this.cachedJsonConfig1 = cloneDeep_1(this.configModel);
                    return this.renderJsonConfigPanel(this.cachedJsonConfig1, 1);
                }
            },
            {
                name: "Authoring View Settings",
                content: () => {
                    const config = this.authorElement ? this.authorElement._configuration : this.configure;
                    this.cachedJsonConfig2 = cloneDeep_1(config);
                    return this.renderJsonConfigPanel(this.cachedJsonConfig2, 2);
                }
            }
        ], 200);
    }
    renderAuthoringHeader(smallView = false) {
        const isToggled = this.isToggled("authoring");
        return (h("div", { class: classnames("authoring-header", {
                collapsed: this.collapsed === "authoring",
                toggled: isToggled
            }) }, h("div", { class: "topContent" }, this.renderHeaderTitleInfo({
            title: isToggled ? "Dev Options" : "Authoring View",
            description: isToggled
                ? "Lorem ipsum dolor sit amet, consectetur adipisicing elit."
                : "The view an author sees when configuring this interaction."
        }), !isToggled && (h("div", { class: "buttons-container" }, h("div", { class: "toggle-container", onClick: () => this.validateItem() }, h("span", { class: "toggle-text" }, "Validate")), h("div", { class: classnames("toggle-container", {
                toggled: this.isToggled("authoring")
            }), onClick: () => this.toggleAuthoringSettings() }, h("i", { class: "material-icons toggle-icon" }, this.authSettVisible ? "toggle_on" : "toggle_off"), h("span", { class: "toggle-text" }, "Dev Options")), smallView && (h("div", { class: "mobile-button", onClick: () => (this.mobileTabIndex = 1) }, h("span", null, "STUDENT VIEW"))))), !isToggled && !smallView && (h("i", { class: classnames("material-icons", "collapse-icon", {
                collapsed: this.collapsed === "student"
            }), onClick: () => this.collapsePanel("student") }, this.collapsed === "student"
            ? "format_indent_decrease"
            : "format_indent_increase")), isToggled && (h("span", { class: "close-icon", onClick: () => this.toggleAuthoringSettings() }, "X"))), h("div", { ref: el => (this.bottomContentRef = el), style: {
                height: '100vh'
            }, class: "bottomContent authoring" }, isToggled && this.renderAuthoringBottomContent())));
    }
    renderRoleConfigContainer() {
        return (h("div", { class: "roles-settings" }, h("h5", null, "Role"), h("div", { class: "roles-options" }, this.customCheckBox({
            label: "Student",
            checked: this.currentOption === "student",
            value: "student",
            action: this.setOption
        }), this.customCheckBox({
            label: "Instructor",
            checked: this.currentOption === "instructor",
            value: "instructor",
            action: this.setOption
        }))));
    }
    renderModeConfigContainer() {
        return (h("div", { class: "modes-settings" }, h("h5", null, "Mode"), h("div", { class: "modes-options" }, this.customCheckBox({
            label: "Gather",
            checked: this.env["mode"] === "gather",
            value: "gather",
            action: this.setMode
        }), this.customCheckBox({
            label: "View",
            checked: this.env["mode"] === "view",
            value: "view",
            action: this.setMode
        }), this.customCheckBox({
            label: "Evaluate",
            checked: this.env["mode"] === "evaluate",
            value: "evaluate",
            action: this.setMode
        }))));
    }
    renderSettingsContainer() {
        return (h("div", { class: "settings-tab-container" }, this.renderModeConfigContainer(), this.renderRoleConfigContainer()));
    }
    renderBottomContent() {
        return this.renderTabs([
            {
                name: "Settings",
                content: this.renderSettingsContainer()
            },
            {
                name: "Embed",
                content: null
            }
        ]);
    }
    renderStudentHeader(smallView = false) {
        return (h("div", { class: classnames("student-view-header", {
                collapsed: this.collapsed === "student",
                toggled: this.isToggled()
            }) }, h("div", { class: "topContent" }, this.renderHeaderTitleInfo({
            title: "Student view",
            description: "The view a student (or instructor) sees when entering or reviewing the interaction.",
            options: [this.env["mode"], this.currentOption]
        }), h("div", { class: "buttons-container" }, h("div", { class: classnames("toggle-container", "student", {
                toggled: this.isToggled()
            }), onClick: () => this.toggleStudentSettings() }, h("i", { class: "material-icons toggle-icon" }, this.studSettVisible ? "toggle_on" : "toggle_off"), h("span", { class: "toggle-text" }, "Options"))), !smallView && (h("i", { class: classnames("material-icons", "collapse-icon", {
                collapsed: this.collapsed === "authoring"
            }), onClick: () => this.collapsePanel("authoring") }, this.collapsed === "authoring"
            ? "format_indent_increase"
            : "format_indent_decrease")), smallView && (h("div", { class: "mobile-button", onClick: () => (this.mobileTabIndex = 0) }, h("span", null, "AUTHORING VIEW")))), h("div", { class: "bottomContent" }, this.renderBottomContent())));
    }
    renderCollapsedPanel(title, toggled = undefined) {
        return (h("div", { class: classnames("collapsed-panel", {
                toggled: toggled
            }) }, h("span", null, title)));
    }
    render() {
        switch (this.state) {
            case ViewState.LOADING:
                return (h("div", { class: "root loading" }, h("div", { class: "lmask" })));
            case ViewState.ERROR:
                return h("div", { id: "error" }, "Error...");
            case ViewState.READY:
                return (h("div", { class: classnames("root", {
                        multiplePies: this.multiplePies
                    }), ref: this.handleRootEl }, this.renderDocHolder(), this.renderContent()));
        }
    }
    static get watchers() { return {
        "pie": ["watchPie"],
        "model": ["updateModel"],
        "configure": ["updateConfigure"],
        "configModel": ["watchConfigModel"],
        "pieElement": ["watchPieElement"],
        "pieElementModel": ["watchPieElementModel"],
        "configElement": ["watchConfigElement"],
        "modelSchemaJSONURI": ["watchModelSchemaJSONURI"],
        "configureSchemaJSONURI": ["watchConfigureSchemaJSONURI"]
    }; }
};
PieDemo.style = pieDemoCss;

export { PieDemo as pie_demo_old };
