import "@pie-framework/pie-player-components";
import { PieModel } from "@pie-framework/pie-player-components/dist/types/interface";
/**
 * This component tries to add multi-items support.
 * It uses many parts from the old component (pie-demo) but also has some pretty big changes
 * Instead of removing the old component, we'll keep it in case the new component
 * breaks, to be able to switch quickly between them
 * The long-term purpose is to support multi-items, I guess, but for now (the reason I started this)
 *    teh purpose was to be able to test complex-rubric integrations
 * The documentation for each item is still item-type oriented now (not multi-item)
 *    ex: math-inline in pie-website will only have math-inline documentation, even if it has multiple item types
**/
export declare class PieDemoNew {
    /**
     * The PIE npm package to demo. e.g. `@pie-element/multiple-choice`
     */
    pie: string;
    /**
     * Removes control bar if true
     * @type {boolean}
     */
    justElement: boolean;
    /**
     * Makes the element have 50% height
     * @type {boolean}
     */
    multiplePies: boolean;
    /**
     * Link to the pie-schema markdown file
     * @type {boolean}
     */
    modelSchemaJSONURI: string;
    /**
     * Link to the pie-schema markdown file
     * @type {boolean}
     */
    configureSchemaJSONURI: string;
    /**
     * Tells the component if it needs to load the elements or not
     */
    load: boolean;
    /**
     * Include an editor in the view
     */
    editor: boolean;
    /**
     * Include an item preview in the view
     */
    preview: boolean;
    /**
     * Include control panel for adjusting player settings.
     */
    playerControls: boolean;
    /**
     * The model for the pie.
     */
    model: PieModel;
    configure: Object;
    render(): any;
}
